#include "stdafx.h"
#include "resource.h"
#include "smwdebug.h"

HINSTANCE hInst;
char filename[MAX_PATH];	// ROM̃t@C
BYTE *rombuf;				// ROM̃oCif[^
DWORD romsize;				// ROM̃TCY
HANDLE hFile;				// ROMt@C̃nh

// t@CJ_CAO
BOOL OpenROM() {
	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(ofn));
	
	ofn.lStructSize = sizeof(ofn);
	ofn.lpstrFilter = "SNES ROM (*.smc)\0*.smc\0ׂẴt@C (*.*)\0*.*\0\0";
	filename[0] = '\0';
	ofn.lpstrFile = filename;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	
	return GetOpenFileName(&ofn);
}

// ROMǂݍ
void ReadROM() {
	DWORD dummy;
	
	hFile = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	romsize = GetFileSize(hFile, NULL);
	rombuf = (BYTE*)GlobalAlloc(GMEM_FIXED, romsize);
	ReadFile(hFile, rombuf, romsize, &dummy, NULL);
}

// ROMۑ
void SaveROM() {
	DWORD dummy;
	
	SetFilePointer(hFile, 0, NULL, FILE_BEGIN);
	WriteFile(hFile, rombuf, romsize, &dummy, NULL);
}

// ROM猻݂̐ݒǂݍ
void LoadSettingFromROM(HWND hwndDlg) {
	// X^[gZNg
	if((rombuf[ADDR_STARTSELECT_1] == STATE_DISABLE_STARTSELECT_1) && 
	   (rombuf[ADDR_STARTSELECT_2] == STATE_DISABLE_STARTSELECT_2))
		SendDlgItemMessage(hwndDlg, IDC_CHECK_STARTSELECT, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_STARTSELECT, BM_SETCHECK, 1, 0);
	
	// p[Abv
	if(rombuf[ADDR_POWERUP] == STATE_DISABLE_POWERUP)
		SendDlgItemMessage(hwndDlg, IDC_CHECK_POWERUP, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_POWERUP, BM_SETCHECK, 1, 0);
	
	// 샂[h
	if(rombuf[ADDR_FREEMOVE] == STATE_DISABLE_FREEMOVE)
		SendDlgItemMessage(hwndDlg, IDC_CHECK_FREEMOVE, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_FREEMOVE, BM_SETCHECK, 1, 0);
	
	// }bvRړ
	if((rombuf[ADDR_MAPWALK_1] == STATE_DISABLE_MAPWALK_1) && 
	   (rombuf[ADDR_MAPWALK_2] == STATE_DISABLE_MAPWALK_2) && 
	   (rombuf[ADDR_MAPWALK_3] == STATE_DISABLE_MAPWALK_3))
		SendDlgItemMessage(hwndDlg, IDC_CHECK_MAPWALK, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_MAPWALK, BM_SETCHECK, 1, 0);
	
	// bV[̉ƂX^[[h
	if(rombuf[ADDR_YOSHIWARP] == STATE_DISABLE_YOSHIWARP)
		SendDlgItemMessage(hwndDlg, IDC_CHECK_YOSHIWARP, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_YOSHIWARP, BM_SETCHECK, 1, 0);
	
	// {Xjf
	if(rombuf[ADDR_BOSSDEMO] == STATE_DISABLE_BOSSDEMO)
		SendDlgItemMessage(hwndDlg, IDC_CHECK_BOSSDEMO, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_BOSSDEMO, BM_SETCHECK, 1, 0);
	
	// X[[V
	if(rombuf[ADDR_SLOWMOTION] == STATE_DISABLE_SLOWMOTION)
		SendDlgItemMessage(hwndDlg, IDC_CHECK_SLOWMOTION, BM_SETCHECK, 0, 0);
	else
		SendDlgItemMessage(hwndDlg, IDC_CHECK_SLOWMOTION, BM_SETCHECK, 1, 0);
	
	// X[[Vx
	SetDlgItemInt(hwndDlg, IDC_EDIT_SLOWSPEED, rombuf[ADDR_SLOWSPEED], FALSE);
}

// ROMɌ݂̐ݒ
void WriteSettingToROM(HWND hwndDlg) {
	// X^[gZNg
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_STARTSELECT, BM_GETCHECK, 0, 0) == 0) {
		rombuf[ADDR_STARTSELECT_1] = STATE_DISABLE_STARTSELECT_1;
		rombuf[ADDR_STARTSELECT_2] = STATE_DISABLE_STARTSELECT_2;
	} else {
		rombuf[ADDR_STARTSELECT_1] = STATE_ENABLE_STARTSELECT_1;
		rombuf[ADDR_STARTSELECT_2] = STATE_ENABLE_STARTSELECT_2;
	}
	
	// p[Abv
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_POWERUP, BM_GETCHECK, 0, 0) == 0)
		rombuf[ADDR_POWERUP] = STATE_DISABLE_POWERUP;
	else
		rombuf[ADDR_POWERUP] = STATE_ENABLE_POWERUP;
	
	// 샂[h
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_FREEMOVE, BM_GETCHECK, 0, 0) == 0)
		rombuf[ADDR_FREEMOVE] = STATE_DISABLE_FREEMOVE;
	else
		rombuf[ADDR_FREEMOVE] = STATE_ENABLE_FREEMOVE;
	
	// }bvRړ
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_MAPWALK, BM_GETCHECK, 0, 0) == 0) {
		rombuf[ADDR_MAPWALK_1] = STATE_DISABLE_MAPWALK_1;
		rombuf[ADDR_MAPWALK_2] = STATE_DISABLE_MAPWALK_2;
		rombuf[ADDR_MAPWALK_3] = STATE_DISABLE_MAPWALK_3;
	} else {
		rombuf[ADDR_MAPWALK_1] = STATE_ENABLE_MAPWALK_1;
		rombuf[ADDR_MAPWALK_2] = STATE_ENABLE_MAPWALK_2;
		rombuf[ADDR_MAPWALK_3] = STATE_ENABLE_MAPWALK_3;
	}
	
	// bV[̉ƂX^[[h
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_YOSHIWARP, BM_GETCHECK, 0, 0) == 0)
		rombuf[ADDR_YOSHIWARP] = STATE_DISABLE_YOSHIWARP;
	else
		rombuf[ADDR_YOSHIWARP] = STATE_ENABLE_YOSHIWARP;
	
	// {Xjf
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_BOSSDEMO, BM_GETCHECK, 0, 0) == 0)
		rombuf[ADDR_BOSSDEMO] = STATE_DISABLE_BOSSDEMO;
	else
		rombuf[ADDR_BOSSDEMO] = STATE_ENABLE_BOSSDEMO;
	
	// X[[V
	if(SendDlgItemMessage(hwndDlg, IDC_CHECK_SLOWMOTION, BM_GETCHECK, 0, 0) == 0)
		rombuf[ADDR_SLOWMOTION] = STATE_DISABLE_SLOWMOTION;
	else
		rombuf[ADDR_SLOWMOTION] = STATE_ENABLE_SLOWMOTION;
	
	// X[[Vx
	rombuf[ADDR_SLOWSPEED] = (BYTE)GetDlgItemInt(hwndDlg, IDC_EDIT_SLOWSPEED, NULL, FALSE);
}

// C_CAȌ
BOOL CALLBACK MainDialogProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	HICON hIcon;
	
	switch(uMsg) {
		case WM_INITDIALOG:	// 
			hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON, 32, 32, LR_DEFAULTCOLOR);
			SendMessage(hwndDlg, WM_SETICON, ICON_BIG, (LPARAM)hIcon);
			hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON1), IMAGE_ICON, 16, 16, LR_DEFAULTCOLOR);
			SendMessage(hwndDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
			LoadSettingFromROM(hwndDlg);
			return TRUE;
		case WM_COMMAND:	// Rg[̃bZ[W
			switch(LOWORD(wParam)) {
				// X[[VXs[hftHgɖ߂
				case IDC_BUTTON_SLOWSPEED_DEFAULT:
					SetDlgItemInt(hwndDlg, IDC_EDIT_SLOWSPEED, DEFAULT_SLOWSPEED, FALSE);
					return TRUE;
				// ۑ
				case IDC_BUTTON_SAVE:
					WriteSettingToROM(hwndDlg);
					SaveROM();
					return TRUE;
				// I
				case IDCANCEL:
					EndDialog(hwndDlg, 0);
					return TRUE;
			}
			return FALSE;
		case WM_CLOSE:	// 
			EndDialog(hwndDlg, 0);
			return TRUE;
	}
	
	return FALSE;
}

// C֐
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {
	hInst = hInstance;
	
	if(strlen(lpszCmdLine) == 0) {
		if(!OpenROM()) return 0;
	} else {
		strcpy(filename, lpszCmdLine);
	}
	
	ReadROM();
	
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, MainDialogProc);
	
	GlobalFree(rombuf);
	CloseHandle(hFile);
	
	return 0;
}
